#ifndef CONFIGURATION_H
#define CONFIGURATION_H
 
#include <QWidget>
#include <QLineEdit>
#include <QTextEdit>
#include <QTabWidget>
#include <QGridLayout>
#include <QHBoxLayout>
#include <QDialog>
#include <QSpinBox>

#include "MainWindow.h"
#include "Const.h"


class QListWidget;
class QListWidgetItem;
class QStackedWidget;

class MainOptions : public QWidget
{
  Q_OBJECT

  public:
    MainOptions(QWidget *parent = 0);
    ~MainOptions();
    QSpinBox* spinBox_;
};



class Configuration : public QDialog
{
  Q_OBJECT

  public:
    Configuration();
    ~Configuration();

  protected:
    void closeEvent(QCloseEvent *event);

  public slots:
    void changePage(QListWidgetItem *current, QListWidgetItem *previous);

  private:
    void createIcons();
    QListWidget *contentsWidget;
    QStackedWidget *pagesWidget;
    void readSettings();
    void writeSettings();
    MainOptions* mainOptions_;
  private slots:
    void accept();
};


//     
//   private:
//     MainWindow* mainWindow_;

//     QTabWidget* tabWidget;
//     
//     QPushButton* okButton_;
//     QPushButton* cancelButton_;

//     void cancel();


#endif

