#ifndef CONST_H
#define CONST_H

#include <string>

using namespace std;

typedef unsigned long long int u64;
typedef unsigned long int u32;
typedef unsigned short int u16;
typedef unsigned char u8;
typedef signed char i8;

enum StoneColour { 
  EMPTY = 0, BLACK = 1, WHITE = 2 
};

enum position { 
  START_BOARD = 0, MID_BOARD = 9, END_BOARD = 18 
};

enum gameresult { 
  BLACKWIN = 0, WHITEWIN = 1, JIGO = 2, BLACKWINTIME = 3, WHITEWINTIME = 4,
  NORESULT = 5
};

enum setupDatabaseError {
  ACCEPT = 0, NAME_TAKEN = 1, NO_SGF = 2, UNABLE_TO_CREATE_DIR = 3, BAD_SGF = 4, DIR_TAKEN = 5,
  CANCEL = 6, BAD_DIRECTORY = 7
};

enum ProcessSection {
  INITIALIZE_GAMES = 0, DUPLICATE_CHECK = 1, PARSE_GAMES = 2, INITIALIZE_PATTERNS = 3
};

enum EditStatus {ERASE, ADDALTERNATE, ADDBLACK, ADDWHITE};

enum Axis {NONE, HORIZONTAL, VERTICAL, DIAGONALXY, DIAGONALOPP};

const u16 WHOLEBOARD_DEPTH = 40; //40 move whole board 'fuseki' search

//sizeof (Struct Patterns) 16 bytes -not including vector<gameList> - Pattern.h
const u8 PATTERNS_SIZE = 16; 
//sizeof(GamesList) is actually more - but we have encoded bits - see Pattern.h
const u8 GAMESLIST_SIZE = 8; 

const u8 PATTERN_NOT_FOUND = 1; //for pattern search
const bool RULESALL = true; //allow non standard sgf with illegal moves

const size_t WB_INVARIANTS = 8;
const u8 BOARD_SIZE = 19; //we only do 19x19 boards - version 0.1

const string LOG_FILENAME("LogFile.txt");

#endif
