
#ifndef DATABASETAB_H
#define DATABASETAB_H

#include <QWidget>
#include <QLabel>
#include <QLineEdit>
#include <QAction>
#include <QMenu>
#include <QModelIndex>
#include <QTreeView>
#include <QEvent>
#include <QPainter>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>

#include "DbManager.h"
#include "DatabaseViewer.h"

class DbManager;
class DatabaseViewer;
class AddDatabase;
class DatabaseTab;

class MyModel : public QStandardItemModel
{
  Q_OBJECT

  public:
    MyModel(QObject *parent = 0);
    
//     bool removeRow(int row, const QModelIndex &parent);
      void emit_layoutChanged ();
    
  public slots:
    
  protected:
      QStringList mimeTypes () const;
//       virtual Qt::DropActions supportedDropActions () const;
//       virtual bool dropMimeData ( const QMimeData * data, Qt::DropAction action, int row, 
//                                    int column, const QModelIndex & parent );
//       virtual Qt::ItemFlags flags ( const QModelIndex & index ) const;
};



class MyTreeView : public QTreeView
{
  Q_OBJECT

  public:
    MyTreeView(DatabaseTab* parent);

     QDrag* drag;
     QMimeData *mimeData;
//     void setMyModel(MyModel* model);
    MyModel* model_;
    void setupModel(MyModel* model);
    Qt::DropAction dropAction;
  public slots:
    
  protected:
      void paintEvent(QPaintEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *event);
      virtual void dragMoveEvent (QDragMoveEvent *event);
//      virtual void dropEvent (QDropEvent *event);
//     virtual void resizeEvent ( QResizeEvent * event );
     void dragEnterEvent(QDragEnterEvent *event);
     void dropEvent(QDropEvent *event);
  private:
     QPoint dragStartPosition;
     bool isDragging_;
     QRect dropSite;
};



class DatabaseTab : public QWidget
{
  Q_OBJECT

  public:
    DatabaseTab(DatabaseViewer* databaseViewer, QWidget *parent = 0);
    ~DatabaseTab();
    void setupModel();
    void writeSettings();
    QItemSelectionModel *selmod;
    
  protected:
    virtual void contextMenuEvent(QContextMenuEvent *event);
    virtual bool event(QEvent *);
    
  private slots:
    void addDatabaseWizard();
    void removeDatabase();
    void changeStatusDatabase(bool on);
    void selectOnlyDatabase();
    void selectAllDatabases();
    void changeColourDatabase();
    void sectionsMoved();
  private:
    
    QDrag* drag;
    QAction* addDatabaseAct;
    QAction* removeDatabaseAct;
    QAction* setStatusDatabaseAct;
    QAction* selectOnlyDatabaseAct;
    QAction* selectAllDatabasesAct;
    QAction* setColourAct;
    MyTreeView *treeView;
    MyModel *model;
    QSortFilterProxyModel *proxyModel;
    QModelIndex modelindex;
    QMenu *databaseMenu;
    DatabaseViewer* databaseViewer_;
//     AddDatabase* addDatabase;
    
    int headerPosDatabase_;
    int headerPosCreated_;
    int headerPosActive_;
    int headerPosGames_;
    int headerPosDirectory_;
    int headerPosRecursive_;
    int headerPosColour_;
    
};

#endif

