//Directory.cpp
//baduK++ 0.1 - Neil Mclean 4/3/2006

#include <iostream>
#include <string>

#include "Directory.h"

using namespace std;

Directory::Directory() : index_(0) {}

Directory::Directory(int idx, string name) : index_(idx), dirpath_(name) {}

Directory::~Directory() {}


u32 Directory::getIndex() const 
{ 
  return index_; 
}



string Directory::getDir() const
{ 
  return dirpath_; 
}



void Directory::writeDir(ostream& ofs)
{
  u32 size = dirpath_.size(); // string::size_type better but undefined length
  try {
    ofs.write(reinterpret_cast<char *>(&index_), sizeof (index_));
    ofs.write(reinterpret_cast<char *>(&size), sizeof (size));
    ofs.write(dirpath_.c_str(), size + 1); // write final '\0' too
  }
  catch (ios_base::failure& e) { 
    cout << "Error I/O failure " << e.what() << endl;
    abort();
  }
}



void Directory::readDir(istream& ifs) 
{
  u32 len = 0;
  char *tmp = 0;
  try {
    ifs.read(reinterpret_cast<char *>(&index_), sizeof (index_));
    ifs.read(reinterpret_cast<char *>(&len), sizeof(len));
    tmp = new char [len + 1]; // allocate temp buffer for name
    ifs.read(tmp, len + 1); // copy name to temp, including '\0'
    dirpath_ = tmp; // copy temp to data member
    delete[] tmp;
  }
  catch (ios_base::failure& e) { 
    cout << "Error I/O failure " << e.what() << endl;
    abort();
  }
}



//////////////////////////////////////////////////////////////////////////
//! DEBUG CODE
//////////////////////////////////////////////////////////////////////////

void Directory::printinfo() const
{ 
  cout << index_ << " " << dirpath_ << endl; 
}

