
#include <QApplication>
#include <QSettings>
#include <QStackedLayout>
#include <QComboBox>
#include <QSizePolicy>
#include <cassert>

#include "GameInfo.h"


GameComment::GameComment(QWidget* parent) : QWidget(parent)
{
  textEditGameComment = new QTextEdit(this);
//   QSizePolicy* sizepol = new QSizePolicy;
//   sizepol->setVerticalPolicy (QSizePolicy::Expanding);
//   textEditGameComment->setSizePolicy(QSizePolicy::Expanding);
  QGridLayout* gameCommentLayout = new QGridLayout;
  gameCommentLayout->addWidget(textEditGameComment, 0, 0, 2, 1);
  setLayout(gameCommentLayout);
}

GameComment::~GameComment() {}


OtherInfo::OtherInfo(QWidget *parent) : QWidget(parent)
{
  QGridLayout* layout = new QGridLayout;
  
  int labelWidth = 80;
  labelAnnotator = new QLabel(this);
  labelAnnotator->setFixedWidth (labelWidth);
  labelTranscriber = new QLabel(this);
  labelTranscriber->setFixedWidth (labelWidth);
  lineEditAnnotator = new QLineEdit(this);
  lineEditTranscriber = new QLineEdit(this);
  
  QHBoxLayout* annotatorLayout = new QHBoxLayout;
  annotatorLayout->addWidget(labelAnnotator);
  annotatorLayout->addWidget(lineEditAnnotator);
  QHBoxLayout* transcriberLayout = new QHBoxLayout;
  transcriberLayout->addWidget(labelTranscriber);
  transcriberLayout->addWidget(lineEditTranscriber);
  
  labelSource = new QLabel(this);
  labelSource->setFixedWidth (labelWidth);
  lineEditSource = new QLineEdit(this);
  
  QHBoxLayout* sourceLayout = new QHBoxLayout;
  sourceLayout->addWidget(labelSource);
  sourceLayout->addWidget(lineEditSource);
  
  labelFilename = new QLabel(this);
  labelFilename->setFixedWidth (labelWidth);
  lineEditFilename = new QLineEdit(this);
  
  QHBoxLayout* filenameLayout = new QHBoxLayout;
  filenameLayout->addWidget(labelFilename);
  filenameLayout->addWidget(lineEditFilename);
  
  lineEditCopyright = new QLineEdit(this);
  labelCopyright = new QLabel(this);
  labelCopyright->setFixedWidth (labelWidth);
  
  QHBoxLayout* copyrightLayout = new QHBoxLayout;
  copyrightLayout->addWidget(labelCopyright);
  copyrightLayout->addWidget(lineEditCopyright);
  
  lineEditApplication = new QLineEdit(this);
  labelApplication = new QLabel(this);
  labelApplication->setFixedWidth (labelWidth);
  
  QHBoxLayout* applicationLayout = new QHBoxLayout;
  applicationLayout->addWidget(labelApplication);
  applicationLayout->addWidget(lineEditApplication);
  
  labelSource->setText(QApplication::translate("GameInfo", "Source", 0, QApplication::UnicodeUTF8));
  labelAnnotator->setText(QApplication::translate("GameInfo", "Annotator", 0, QApplication::UnicodeUTF8));
  labelTranscriber->setText(QApplication::translate("GameInfo", "Transcriber", 0, QApplication::UnicodeUTF8));
  labelCopyright->setText(QApplication::translate("GameInfo", "Copyright", 0, QApplication::UnicodeUTF8));
  labelFilename->setText(QApplication::translate("GameInfo", "Filename", 0, QApplication::UnicodeUTF8));
  labelApplication->setText(QApplication::translate("GameInfo", "Application", 0, QApplication::UnicodeUTF8));
  
  labelSource->setBuddy(lineEditSource);
  labelAnnotator->setBuddy(lineEditAnnotator);
  labelTranscriber->setBuddy(lineEditTranscriber);
  labelCopyright->setBuddy(lineEditCopyright);
  labelFilename->setBuddy(lineEditFilename);
  labelApplication->setBuddy(lineEditApplication);
  
  layout->addItem(annotatorLayout, 0, 0, 1, 2);
  layout->addItem(transcriberLayout, 1, 0, 1, 2);
  layout->addItem(sourceLayout, 2, 0, 1, 2);
  layout->addItem(applicationLayout, 3, 0, 1, 2);
  layout->addItem(copyrightLayout, 4, 0, 1, 2);
  layout->addItem(filenameLayout, 5, 0, 1, 2);
  
  QSpacerItem* spacer = new QSpacerItem( 10, 600, QSizePolicy::Minimum, QSizePolicy::Minimum);
  layout->addItem(spacer, 6, 0, 1, 2);

  setLayout(layout);
}

OtherInfo::~OtherInfo() {}


MainInfo::MainInfo(QWidget *parent) : QWidget(parent)
{
  int labelWidth = 80;
  QGridLayout* layout = new QGridLayout;
  
  labelGameName = new QLabel(this);
  labelGameName->setFixedWidth (labelWidth);
  lineEditGameName = new QLineEdit(this);
  QHBoxLayout* gameNameLayout = new QHBoxLayout;
  gameNameLayout->addWidget(labelGameName);
  gameNameLayout->addWidget(lineEditGameName);
  
  labelPlayerBlack = new QLabel(this);
  labelPlayerBlack->setFixedWidth (labelWidth);
  labelPlayerWhite = new QLabel(this);
  labelPlayerWhite->setFixedWidth (labelWidth);
  lineEditPlayerWhite = new QLineEdit(this);
  lineEditPlayerBlack = new QLineEdit(this);
  
  QHBoxLayout* whitePlayerLayout = new QHBoxLayout;
  whitePlayerLayout->addWidget(labelPlayerBlack);
  whitePlayerLayout->addWidget(lineEditPlayerBlack);
  QHBoxLayout* blackPlayerLayout = new QHBoxLayout;
  blackPlayerLayout->addWidget(labelPlayerWhite);
  blackPlayerLayout->addWidget(lineEditPlayerWhite);
  
  labelRankBlack = new QLabel(this);
  labelRankBlack->setFixedWidth (labelWidth);
  labelRankWhite = new QLabel(this);
  labelRankWhite->setFixedWidth (labelWidth);
  lineEditRankWhite = new QLineEdit(this);
  lineEditRankBlack = new QLineEdit(this);
  
  QHBoxLayout* blackRankLayout = new QHBoxLayout;
  blackRankLayout->addWidget(labelRankBlack);
  blackRankLayout->addWidget(lineEditRankBlack);
  QHBoxLayout* whiteRankLayout = new QHBoxLayout;
  whiteRankLayout->addWidget(labelRankWhite);
  whiteRankLayout->addWidget(lineEditRankWhite);
  
  labelWhiteTeam = new QLabel(this);
  labelWhiteTeam->setFixedWidth (labelWidth);
  labelBlackTeam = new QLabel(this);
  labelBlackTeam->setFixedWidth (labelWidth);
  lineEditWhiteTeam = new QLineEdit(this);
  lineEditBlackTeam = new QLineEdit(this);
  
  QHBoxLayout* whiteTeamLayout = new QHBoxLayout;
  whiteTeamLayout->addWidget(labelWhiteTeam);
  whiteTeamLayout->addWidget(lineEditWhiteTeam);
  QHBoxLayout* blackTeamLayout = new QHBoxLayout;
  blackTeamLayout->addWidget(labelBlackTeam);
  blackTeamLayout->addWidget(lineEditBlackTeam);
  
  labelResult = new QLabel(this);
  labelResult->setFixedWidth (labelWidth);
  labelKomi = new QLabel(this);
  labelKomi->setFixedWidth (labelWidth);
  lineEditResult = new QLineEdit(this);
  lineEditKomi = new QLineEdit(this);
  
  QHBoxLayout* resultLayout = new QHBoxLayout;
  resultLayout->addWidget(labelResult);
  resultLayout->addWidget(lineEditResult);
  QHBoxLayout* komiLayout = new QHBoxLayout;
  komiLayout->addWidget(labelKomi);
  komiLayout->addWidget(lineEditKomi);
  
  labelHandicap = new QLabel(this);
  labelHandicap->setFixedWidth (labelWidth);
  lineEditHandicap = new QLineEdit(this);
  labelSize = new QLabel(this);
  labelSize->setFixedWidth (labelWidth);
  lineEditSize = new QLineEdit(this);
  
  QHBoxLayout* handicapLayout = new QHBoxLayout;
  handicapLayout->addWidget(labelHandicap);
  handicapLayout->addWidget(lineEditHandicap);
  QHBoxLayout* sizeLayout = new QHBoxLayout;
  sizeLayout->addWidget(labelSize);
  sizeLayout->addWidget(lineEditSize);
  
  labelEvent = new QLabel(this);
  labelEvent->setFixedWidth (labelWidth);
  labelPlace = new QLabel(this);
  labelPlace->setFixedWidth (labelWidth);
  lineEditEvent = new QLineEdit(this);
  lineEditPlace = new QLineEdit(this);
  
  QHBoxLayout* eventLayout = new QHBoxLayout;
  eventLayout->addWidget(labelEvent);
  eventLayout->addWidget(lineEditEvent);
  QHBoxLayout* placeLayout = new QHBoxLayout;
  placeLayout->addWidget(labelPlace);
  placeLayout->addWidget(lineEditPlace);
  
  
  labelRules = new QLabel(this);
  labelRules->setFixedWidth (labelWidth);
  lineEditRules = new QLineEdit(this);
  
  QHBoxLayout* rulesLayout = new QHBoxLayout;
  rulesLayout->addWidget(labelRules);
  rulesLayout->addWidget(lineEditRules);
  
  labelTime = new QLabel(this);
  labelTime->setFixedWidth (labelWidth);
  labelOverTime = new QLabel(this);
  labelOverTime->setFixedWidth (labelWidth);
  lineEditTime = new QLineEdit(this);
  lineEditOverTime = new QLineEdit(this);
  
  QHBoxLayout* timeLayout = new QHBoxLayout;
  timeLayout->addWidget(labelTime);
  timeLayout->addWidget(lineEditTime);
  QHBoxLayout* overTimeLayout = new QHBoxLayout;
  overTimeLayout->addWidget(labelOverTime);
  overTimeLayout->addWidget(lineEditOverTime);
  
  labelRound = new QLabel(this);
  labelRound->setFixedWidth (labelWidth);
  lineEditRound = new QLineEdit(this);
  
  QHBoxLayout* roundLayout = new QHBoxLayout;
  roundLayout->addWidget(labelRound);
  roundLayout->addWidget(lineEditRound);
  
  labelDate = new QLabel(this);
  labelDate->setFixedWidth (labelWidth);
  lineEditDate = new QLineEdit(this);
  
  QHBoxLayout* dateLayout = new QHBoxLayout;
  dateLayout->addWidget(labelDate);
  dateLayout->addWidget(lineEditDate);
  
  layout->addItem(gameNameLayout, 0, 0, 1, 2);
  layout->addItem(whitePlayerLayout, 1, 0, 1, 1);
  layout->addItem(blackPlayerLayout, 1, 1, 1, 1);
  layout->addItem(blackRankLayout, 2, 0, 1, 1);
  layout->addItem(whiteRankLayout, 2, 1, 1, 1);
  layout->addItem(whiteTeamLayout, 3, 0, 1, 1);
  layout->addItem(blackTeamLayout, 3, 1, 1, 1);
  layout->addItem(resultLayout, 4, 0, 1, 1);
  layout->addItem(komiLayout, 4, 1, 1, 1);
  layout->addItem(handicapLayout, 5, 0, 1, 1);
  layout->addItem(sizeLayout, 5, 1, 1, 1);
  
  layout->addItem(eventLayout, 6, 0, 1, 2);
  layout->addItem(placeLayout, 7, 0, 1, 2);
  
  layout->addItem(dateLayout, 8, 0, 1, 2);
  layout->addItem(rulesLayout, 9, 0, 1, 2);
  layout->addItem(roundLayout, 10, 0, 1, 2);
  
  layout->addItem(timeLayout, 11, 0, 1, 2);
  layout->addItem(overTimeLayout, 12, 0, 1, 2);
  
  QSpacerItem* spacer = new QSpacerItem( 10, 600, QSizePolicy::Minimum, QSizePolicy::Minimum);
  layout->addItem(spacer, 13, 0, 1, 2);
  
  setLayout(layout);
  
  labelPlayerWhite->setText(QApplication::translate("GameInfo", "White ", 0, QApplication::UnicodeUTF8));
  
  labelPlayerBlack->setText(QApplication::translate("GameInfo", "Black ", 0, QApplication::UnicodeUTF8));
  
  labelRankWhite->setText(QApplication::translate("GameInfo", "Rank ", 0, QApplication::UnicodeUTF8));
  
  labelRankBlack->setText(QApplication::translate("GameInfo", "Rank ", 0, QApplication::UnicodeUTF8));
  
  labelResult->setText(QApplication::translate("GameInfo", "Result", 0, QApplication::UnicodeUTF8));
  labelEvent->setText(QApplication::translate("GameInfo", "Event", 0, QApplication::UnicodeUTF8));
  labelPlace->setText(QApplication::translate("GameInfo", "Place", 0, QApplication::UnicodeUTF8));
  labelDate->setText(QApplication::translate("GameInfo", "Date", 0, QApplication::UnicodeUTF8));
  labelHandicap->setText(QApplication::translate("GameInfo", "Handicap", 0, QApplication::UnicodeUTF8));
  labelKomi->setText(QApplication::translate("GameInfo", "Komi", 0, QApplication::UnicodeUTF8));
//   qDebug("here6");
  
  labelTime->setText(QApplication::translate("GameInfo", "Time", 0, QApplication::UnicodeUTF8));
  labelOverTime->setText(QApplication::translate("GameInfo", "Over Time", 0, QApplication::UnicodeUTF8));
  labelRound->setText(QApplication::translate("GameInfo", "Round", 0, QApplication::UnicodeUTF8));
  
  labelRules->setText(QApplication::translate("GameInfo", "Rules", 0, QApplication::UnicodeUTF8));
  labelGameName->setText(QApplication::translate("GameInfo", "Game Name ", 0, QApplication::UnicodeUTF8));
  
  labelWhiteTeam->setText(QApplication::translate("GameInfo", "White Team", 0, QApplication::UnicodeUTF8));
  labelBlackTeam->setText(QApplication::translate("GameInfo", "Black Team", 0, QApplication::UnicodeUTF8));
  
  labelSize->setText(QApplication::translate("GameInfo", "Size", 0, QApplication::UnicodeUTF8));
  
  labelPlayerBlack->setBuddy(lineEditPlayerBlack);
  labelRankBlack->setBuddy(lineEditRankBlack);
  labelPlayerWhite->setBuddy(lineEditPlayerWhite);
  labelRankWhite->setBuddy(lineEditRankWhite);
  labelResult->setBuddy(lineEditResult);
  labelEvent->setBuddy(lineEditEvent);
  labelPlace->setBuddy(lineEditPlace);
  labelDate->setBuddy(lineEditDate);
  labelHandicap->setBuddy(lineEditHandicap);
  labelKomi->setBuddy(lineEditKomi);
  labelSize->setBuddy(lineEditSize);
  
  
  labelTime->setBuddy(lineEditTime);
  labelOverTime->setBuddy(lineEditOverTime);
  labelRound->setBuddy(lineEditRound);
  
  labelRules->setBuddy(lineEditRules);
  labelGameName->setBuddy(lineEditGameName);
  labelWhiteTeam->setBuddy(lineEditWhiteTeam);
  labelBlackTeam->setBuddy(lineEditBlackTeam);
  
  
  /*
  QWidget::setTabOrder(lineEditPlayerWhite, lineEditRankWhite);
  QWidget::setTabOrder(lineEditRankWhite, lineEditPlayerBlack);
  QWidget::setTabOrder(lineEditPlayerBlack, lineEditRankBlack);
  QWidget::setTabOrder(lineEditRankBlack, lineEditKomi);
  QWidget::setTabOrder(lineEditKomi, lineEditHandicap);
  QWidget::setTabOrder(lineEditHandicap, lineEditDate);
  QWidget::setTabOrder(lineEditDate, lineEditResult);
  QWidget::setTabOrder(lineEditResult, lineEditPlace);
  QWidget::setTabOrder(lineEditPlace, lineEditEvent);
  
  QWidget::setTabOrder(lineEditEvent, lineEditApplication);
  QWidget::setTabOrder(lineEditApplication, lineEditTime);
  QWidget::setTabOrder(lineEditTime, lineEditOverTime);
  QWidget::setTabOrder(lineEditOverTime, lineEditRound);
  QWidget::setTabOrder(lineEditRound, lineEditCopyright);
  QWidget::setTabOrder(lineEditCopyright, lineEditFilename);
  QWidget::setTabOrder(lineEditFilename, lineEditRules);
  QWidget::setTabOrder(lineEditRules, lineEditGameName);
  QWidget::setTabOrder(lineEditGameName, lineEditGameComment);
  QWidget::setTabOrder(lineEditGameComment, lineEditWhiteTeam);
  QWidget::setTabOrder(lineEditWhiteTeam, lineEditBlackTeam);
  QWidget::setTabOrder(lineEditBlackTeam, lineEditSource);
  QWidget::setTabOrder(lineEditSource, lineEditAnnotator);
  QWidget::setTabOrder(lineEditAnnotator, lineEditTranscriber);
  */
}

MainInfo::~MainInfo() {}


GameInfo::GameInfo(MainWindow* mainWindow, QWidget *parent) : QWidget(parent), mainWindow_(mainWindow)
{
  mainInfo = new MainInfo;
  otherInfo = new OtherInfo;
  gameComment = new GameComment;
  tabWidget = new QTabWidget;
  
  tabWidget->setTabPosition (QTabWidget::North);
  tabWidget->addTab(mainInfo, tr("General Info"));
  tabWidget->addTab(otherInfo, tr("Other Info"));
  tabWidget->addTab(gameComment, tr("Game Comment"));
  tabWidget->setMinimumSize ( 300, 400 );
  
  QVBoxLayout *mainLayout = new QVBoxLayout;
  mainLayout->addWidget(tabWidget);
  setLayout(mainLayout);
  setWindowTitle(tr("Game Information"));
  readSettings();
}


GameInfo::~GameInfo() {}


// populateInfo(database, gameindex);
void GameInfo::populateInfo(std::string database, u32 index)
{
  Database* db = mainWindow_->dbManager_->getDatabasePointer(database);
  map<u32,boost::shared_ptr<Game> >::const_iterator Gpos;
  Gpos = db->Games.find(index);
  assert(Gpos != db->Games.end());
  std::string dbDirpath = db->getDir(Gpos->second->getDirkey());
  Gpos->second->initializeGameInfo(dbDirpath);
//   std::cout << "pop info 3" << std::endl;
  
  mainInfo->lineEditPlayerWhite->setText((Gpos->second->getPlayerW()).c_str());
  mainInfo->lineEditPlayerBlack->setText((Gpos->second->getPlayerB()).c_str());
  mainInfo->lineEditRankWhite->setText((Gpos->second->getRankW()).c_str());
  mainInfo->lineEditRankBlack->setText((Gpos->second->getRankB()).c_str());
  mainInfo->lineEditKomi->setText((Gpos->second->getKomi()).c_str());
  mainInfo->lineEditDate->setText((Gpos->second->getDate()).c_str());
  mainInfo->lineEditResult->setText((Gpos->second->getResultStr()).c_str());
  mainInfo->lineEditHandicap->setText((Gpos->second->getHandicap()).c_str());
  mainInfo->lineEditPlace->setText((Gpos->second->getPlace()).c_str());
  mainInfo->lineEditEvent->setText((Gpos->second->getEvent()).c_str());
  
  mainInfo->lineEditTime->setText((Gpos->second->getTime()).c_str());
  mainInfo->lineEditOverTime->setText((Gpos->second->getOverTime()).c_str());
  mainInfo->lineEditRound->setText((Gpos->second->getRound()).c_str());
  mainInfo->lineEditRules->setText((Gpos->second->getRules()).c_str());
  mainInfo->lineEditGameName->setText((Gpos->second->getGameName()).c_str());
  mainInfo->lineEditWhiteTeam->setText((Gpos->second->getWhiteTeam()).c_str());
  mainInfo->lineEditBlackTeam->setText((Gpos->second->getBlackTeam()).c_str());
  
  otherInfo->lineEditCopyright->setText((Gpos->second->getCopyright()).c_str());
  
  std::string fullPath = dbDirpath + "/" + Gpos->second->getFilename();
  otherInfo->lineEditFilename->setText(fullPath.c_str());
  otherInfo->lineEditSource->setText((Gpos->second->getSource()).c_str());
  otherInfo->lineEditAnnotator->setText((Gpos->second->getAnnotator()).c_str());
  otherInfo->lineEditTranscriber->setText((Gpos->second->getTranscriber()).c_str());
  otherInfo->lineEditApplication->setText((Gpos->second->getApplication()).c_str());
  
  gameComment->textEditGameComment->setPlainText((Gpos->second->getGameComment()).c_str());
}



void GameInfo::closeEvent(QCloseEvent *event)
{
  writeSettings();
  mainWindow_->gameInfoAct_->setChecked(false);
  event->accept();
}



void GameInfo::readSettings()
{
  QSettings settings;
  settings.beginGroup("GameInfo");
  QPoint pos = settings.value("pos", QPoint(0, 420)).toPoint();
  QSize size = settings.value("size", QSize(400, 50)).toSize();
  settings.endGroup();
  resize(size);
  move(pos);
}



void GameInfo::writeSettings()
{
  QSettings settings;
  settings.beginGroup("GameInfo");
  settings.setValue("pos", pos());
  settings.setValue("size", size());
  settings.endGroup();
}
