#ifndef GAMEINFO_H
#define GAMEINFO_H
 
#include <QWidget>
#include <QLabel>
#include <QLineEdit>
#include <QTextEdit>

#include "Const.h"
#include "MainWindow.h"

class MainWindow;


class OtherInfo : public QWidget
{
  Q_OBJECT

  public:
    OtherInfo(QWidget *parent = 0);
    ~OtherInfo();

    QLabel *labelSource;
    QLabel *labelAnnotator;
    QLabel *labelTranscriber;
    QLineEdit *lineEditSource;
    QLineEdit *lineEditAnnotator;
    QLineEdit *lineEditTranscriber;
    
    QLineEdit *lineEditCopyright;
    QLineEdit *lineEditFilename;
    QLabel *labelCopyright;
    QLabel *labelFilename;
    QLineEdit *lineEditApplication;
    QLabel *labelApplication;
    
};



class GameComment : public QWidget
{
  Q_OBJECT

  public:
    GameComment(QWidget *parent = 0);
    ~GameComment();
    QTextEdit *textEditGameComment;
};



class MainInfo : public QWidget
{
  Q_OBJECT

  public:
    MainInfo(QWidget *parent = 0);
    ~MainInfo();
//     void populateInfo(std::string database, u32 index);
    QLabel *labelPlayerWhite;
    QLabel *labelPlayerBlack;
    QLabel *labelRankWhite;
    QLabel *labelRankBlack;
    QLabel *labelResult;
    QLabel *labelEvent;
    QLabel *labelPlace;
    QLabel *labelDate;
    QLabel *labelHandicap;
    QLabel *labelKomi;
    QLabel* labelSize;
  
    
    QLabel *labelTime;
    QLabel *labelOverTime;
    QLabel *labelRound;
    
    QLabel *labelRules;
    QLabel *labelGameName;
    
    QLabel *labelWhiteTeam;
    QLabel *labelBlackTeam;
    
  
    QLineEdit *lineEditPlayerWhite;
    QLineEdit *lineEditPlayerBlack;
    QLineEdit *lineEditRankWhite;
    QLineEdit *lineEditRankBlack;
    QLineEdit *lineEditResult;
    QLineEdit *lineEditEvent;
    QLineEdit *lineEditPlace;
    QLineEdit *lineEditDate;
    QLineEdit *lineEditHandicap;
    QLineEdit *lineEditKomi;
  
    
    QLineEdit *lineEditTime;
    QLineEdit *lineEditOverTime;
    QLineEdit *lineEditRound;
    
    QLineEdit *lineEditRules;
    QLineEdit *lineEditGameName;
    
    QLineEdit *lineEditWhiteTeam;
    QLineEdit *lineEditBlackTeam;
    QLineEdit* lineEditSize;
};



class GameInfo : public QWidget
{
  Q_OBJECT

public:
  GameInfo(MainWindow* mainWindow, QWidget *parent = 0);
  ~GameInfo();
  void populateInfo(std::string database, u32 index);
protected:
  void closeEvent(QCloseEvent *event);

private:
  QTabWidget *tabWidget;
  MainInfo* mainInfo;
  OtherInfo* otherInfo;
  GameComment* gameComment;
  void readSettings();
  void writeSettings();
  MainWindow* mainWindow_;
};

#endif 
