//LogFile.cpp
//baduK++ 0.1 - Neil Mclean 13/4/2006

#include "LogFile.h"

using namespace std;

// using boost::filesystem::path;
// using boost::filesystem::native;
// using boost::filesystem::directory_iterator;

LogFile::LogFile() : isLocalDateTime_(true), isOpen_(false) {}

LogFile::~LogFile() {}


void LogFile::close() 
{
  ofs_.close(); 
  isOpen_ = false; 
}


void LogFile::open() 
{
  try {
    ofs_.clear();
    ofs_.open(LOG_FILENAME.c_str(), ios_base::out | ios_base::app);
    if (ofs_.is_open() == false) { 
      throw ios_base::failure (LOG_FILENAME);
    }
    else {
      isOpen_ = true;
    }
    time_t now = time(0); // Convert now to tm struct for local timezone
    tm* localtm = localtime(&now);
    tm* gmtm = gmtime(&now); // Convert now to tm struct for UTC
    //if (0 == gmtm) { // The UTC date and time is: " << asctime(gmtm)
      //cerr << "Failed to get the UTC date and time" << endl; 
    //}
    if (true == isLocalDateTime_) {
      ofs_ << "\n\n** Badukk LogFile " << asctime(localtm) << endl;
    }
    else {
      ofs_ << "\n\n** Badukk LogFile " << asctime(gmtm) << endl;
    }
  }
  catch ( ios_base::failure& e) {
    cout << "Error I/O failure " << e.what() << endl; 
    abort();
  }
}



//!!!! NEEDS FIX
void LogFile::log(const string& value)
{ 
  try { 
    ofs_ << value << endl; 
  }
  catch (exception& e) { 
    cerr << e.what( ) << endl; 
    abort();
  }
}



void LogFile::log(const string& value, const int val){
  try { 
    ofs_ << value << val << endl; 
  }
  catch (exception& e) { 
    cerr << e.what() << endl; 
    abort();
  }
}



void LogFile::erase() { //Erases logfile
  using namespace boost::filesystem;
  path fullPath = complete (path (LOG_FILENAME, native));
  remove(fullPath);
}
