#include <QApplication>
#include <QDir>

#include "Resources.h"

QString Resources::path(QString append)
{
#if defined(Q_OS_MACX)
	return qApp->applicationDirPath() + "/../Resources/" + append;
#else
	return qApp->applicationDirPath() + "/resources/" + append;
#endif
}

QString Resources::userPath(void)
{
	// TODO: Do some error handling for the rare, exceptional, and completely
	// absurd case when the user doesn't have write access to his own home
	// directory?
#if defined(Q_OS_MACX)
	QDir dir = QDir::homePath() + QString("/Library/Application Support");
	dir.mkdir("Baduk");
	dir.cd("Baduk");
	dir.mkdir("Databases");
	return dir.absolutePath();
#elif defined(Q_OS_UNIX)
	QDir dir = QDir::homePath();
	dir.mkdir(".baduk");
	dir.cd(".baduk");
	dir.mkdir("Databases");
	return dir.absolutePath();
#else
	// Fall back on app directory
	return qApp->applicationDirPath();
#endif
}
