//Sgf.cpp
//baduK++ 0.1 - Neil Mclean 5/4/2006

#include <string>
#include <iostream>
#include <fstream>
#include <map>

#include <QApplication>

#include "Sgf.h"
#include "Const.h"

#ifdef WIN32
#include <C:\Boost\include\boost-1_33_1\boost\shared_ptr.hpp>
#else
#include "boost/shared_ptr.hpp"
#endif



using namespace std;

Sgf::Sgf() { 
  initTransArrays(); 
}


Sgf::~Sgf() { 
  //cout << "destructor called" << endl;
}

const string SgfPlayerW("PW");
const string SgfPlayerB("PB");
const string SgfRankW("WR");
const string SgfRankB("BR");
const string SgfResult("RE");
const string SgfKomi("KM");
const string SgfDate("DT");
const string SgfGame("GM");
const string SgfApplication("AP");
const string SgfFF("FF");
const string SgfST("ST");
const string SgfSize("SZ");
const string SgfHandicap("HA");
const string SgfTime("TM");
const string SgfOvertime("OT");
const string SgfPlace("PC");
const string SgfComment("C");
const string SgfEvent("EV");
const string SgfRound("RO");

const string SgfRules("RU");
const string SgfGameName("GN");
const string SgfCopyright("CP");
const string SgfTranscriber("US");
const string SgfAnnotator("AN");
const string SgfSource("SO");
const string SgfBlackTeam("BT");
const string SgfWhiteTeam("WT");
const string SgfGameComment("GC");


string Sgf::getPlayerW() const { return getString("PW"); }
string Sgf::getPlayerB() const { return getString("PB"); }
string Sgf::getRankW() const { return getString("WR"); }
string Sgf::getRankB() const { return getString("BR"); }
string Sgf::getResultStr() const { return getString("RE"); }
string Sgf::getKomi() const { return getString("KM"); }
string Sgf::getDate() const { return getString("DT"); }
string Sgf::getGame() const { return getString("GM"); }
string Sgf::getApplication() const { return getString("AP"); }
string Sgf::getFF() const { return getString("FF"); }
string Sgf::getST() const { return getString("ST"); }
string Sgf::getSize() const { return getString("SZ"); }
string Sgf::getHandicap() const { return getString("HA"); }
string Sgf::getTime() const { return getString("TM"); }
string Sgf::getOverTime() const { return getString("OT"); }
string Sgf::getPlace() const { return getString("PC"); }
string Sgf::getComment() const { return getString("C"); }
string Sgf::getEvent() const { return getString("EV"); }
string Sgf::getRound() const { return getString("RO"); }

string Sgf::getRules() const { return getString("RU"); }
string Sgf::getGameName() const { return getString("GN"); }
string Sgf::getCopyright() const { return getString("CP"); }
string Sgf::getTranscriber() const { return getString("US"); }
string Sgf::getAnnotator() const { return getString("AN"); }
string Sgf::getSource() const { return getString("SO"); }
string Sgf::getBlackTeam() const { return getString("BT"); }
string Sgf::getWhiteTeam() const { return getString("WT"); }
string Sgf::getGameComment() const { return getString("GC"); }
  
  
  
  
string Sgf::getString(string value) const
{
  string str;
  value+="[";
  string::size_type posBeg = sgfFile_.find(value.c_str());
  if (posBeg != string::npos) {
    string::size_type posEnd = posBeg + 2;
    while (sgfFile_[posEnd] != ']') { 
      ++posEnd;
    }
    str.assign(sgfFile_, posBeg + 3, (posEnd - posBeg - 3)); 
  }
  //else { cout << "sgf sgfFile_er tag not found" << endl; }
  return str;
}



//---------------------------------------------------------------------
//returns the result of a game - See Const.h for details of return value
u8 Sgf::getResult()
{
  string str = "";
  string::size_type posBeg = sgfFile_.find((SgfResult + "[").c_str());
  if( posBeg != string::npos ) {
    string::size_type posEnd = posBeg+2;
    while (sgfFile_[posEnd] != ']') { 
      ++posEnd; 
    }
    str.assign(sgfFile_, posBeg+3, (posEnd-posBeg-3)); 
  }
  
  StringToLower(str); // convert str to lower case
  string result;
  result.assign(str, 0, 2); //get the first 2 characters of result
  if ("B+" == result) {
    return BLACKWIN;
  }
  if ("b+" == result) {
    return BLACKWIN;
  }
  if ("W+" == result) {
    return WHITEWIN;
  }
  if ("w+" == result) {
    return WHITEWIN;
  }
  result.assign(str, 0, 4);
  if ("JIGO" == result) {
    return JIGO;
  }
  if ("jigo" == result) {
    return JIGO;
  }
  result.assign(str, 0, 3);
  if ("B+T" == result) {
    return BLACKWINTIME;
  }
  if ("b+t" == result) {
    return BLACKWINTIME;
  }
  if ("W+T" == result) {
    return WHITEWINTIME;
  }
  if ("w+t" == result) {
    return WHITEWINTIME;
  }
  
  //no good result - possibly 'left unfinished' result - or non english
  
//   return NORESULT;
  // For no good result we will return JIGO to signify that no side won or lost
  // This is used in creating statistics, where its helpful to signify no result
  // same as a jigo
  return JIGO;
}




//change each element of the string to lower case
void Sgf::StringToLower(string& strToConvert) 
{
  for(string::size_type i = 0; i < strToConvert.length(); i++) {
    strToConvert[i] = tolower(strToConvert[i]);
  }
}




FullMove Sgf::getMove(const u16 number) const
{
  FullMove move = moves[number];
  return moves[number]; 
}



//read in the sgf file into a string to process
void Sgf::read(const string& filename) 
{
  sgfFile_.clear();
  try {
    ifstream file;
    file.clear(); 
    file.open(filename.c_str());
    if (file.is_open() == false) {
      throw ios_base::failure(filename);
    }
    string line;
    while (file.eof() == false) {
      getline(file, line);
      sgfFile_ += line;
    }
    file.close();
  }
  catch (ios_base::failure& e) { 
    cout << "Error I/O failure " << e.what() << endl;
    abort();
  }
}





//---------------------------------------------------------------
//! Does not take into account variations
//---------------------------------------------------------------
u16 Sgf::extractMoves()
{
  if (moves.empty() == false) { 
    moves.clear(); 
  }
  string str = "";
  FullMove current;
  string::size_type pos = 0;
  while (pos != sgfFile_.length()) {
    str.assign(sgfFile_, pos, SgfADDBLACKMOVE.length());
    if (SgfADDBLACKMOVE == str) { 
      pos += SgfADDBLACKMOVE.length();
      addHandicapStones(pos, BLACK); 
    }
    str.assign(sgfFile_, pos, SgfADDWHITEMOVE.length());
    if (SgfADDWHITEMOVE == str) { 
      pos += SgfADDWHITEMOVE.length();
      addHandicapStones(pos, WHITE); 
    }
    str.assign(sgfFile_, pos, SgfBLACKMOVE.length());
    if (SgfBLACKMOVE == str) { //store moves in 0-19 format
      current.x = sgfFile_[pos + SgfBLACKMOVE.length()] - 'a'; 
      current.y = sgfFile_[pos + SgfBLACKMOVE.length() + 1] - 'a';
      current.colour = BLACK;
      //if ((current.x >= 0) && (current.x <= 18) && (current.y >= 0) && 
      //    (current.y <= 18)) { 
      if ((current.x <= 18) && (current.y <= 18)) { 
        moves.push_back(current); 
//         cout << "xy=" << (int)current.x << " " << (int)current.y << endl;
      }
      pos += 3;
    }
    str.assign(sgfFile_, pos, SgfWHITEMOVE.length());
    if (SgfWHITEMOVE == str) {
      current.x = sgfFile_[pos + SgfWHITEMOVE.length()] - 'a';
      current.y = sgfFile_[pos + SgfWHITEMOVE.length() + 1] - 'a';
      current.colour = WHITE;
      //if ((current.x >= 0) && (current.x <= 18) && (current.y >= 0) && 
       //    (current.y <= 18)) { 
        
      if ((current.x <= 18) && (current.y <= 18)) {
        moves.push_back(current); 
//         cout << "xy=" << (int)current.x << " " << (int)current.y << endl;
      }
      pos += 3;
    }
    ++pos;
  }
  return moves.size();
}



//------------------------------------------------------------------------
//some games have handicap stone placements in different order
//Store all handicap stones in a map, so to sort them based on string value
//then insert them in a map to read back sorted.
//------------------------------------------------------------------------
void Sgf::addHandicapStones(string::size_type& pos, StoneColour colour) 
{
  map<string,boost::shared_ptr<FullMove> > handicaps;
  FullMove current;
  string move;
  bool hasMoreStones = true;
  while (true == hasMoreStones) {
    try {
      move = sgfFile_[pos] + sgfFile_[pos + 1];
      if (BLACK == colour) { 
        move += 'B'; 
      }
      if (WHITE == colour) { 
        move += 'W'; 
      }
      boost::shared_ptr<FullMove> currentPtr (new FullMove());
      currentPtr->x = sgfFile_[pos] - 'a'; //store moves 0-19
      currentPtr->y = sgfFile_[pos+1] - 'a';
      currentPtr->colour = colour;
      if ((current.x < 19) & (current.y < 19)) {
        handicaps.insert (make_pair(move, currentPtr));
      }
      //repeat if there is another handicap stone
      //add size of a move and brackets - 4 chars '[aa]' to position in sgf
      if ('[' == sgfFile_[pos + 3])  {
        pos += 4; 
      }
      else { 
        hasMoreStones = false; 
      }
    }
    catch (bad_alloc& e) { 
      cout << "Error allocating memory " << e.what() << endl; 
    }
  }
  //Go through our sorted list of handicap stones
  map<string, boost::shared_ptr<FullMove> >::const_iterator i;
  for (i = handicaps.begin(); i != handicaps.end(); i++) {
    current.x = i->second->x;
    current.y = i->second->y;
    current.colour = i->second->colour;
    moves.push_back(current);
  }
}



//----------------------------------------------------------------------
//Tranform moves to a common starting board orientation - for duplicate check
//! recursive function - seems to find more duplicates
//try to find the first move that will break the symmetry of the board
//Continues recursive call until a move is not on a symmetrical line
//! There are possibly other duplicates that this cannot catch
//! Ideas needed - not important enough right now 5/4/06
//----------------------------------------------------------------------

bool Sgf::movesInvariant() 
{
  FullMove copy;
  FullMove move;
  bool doHorizontal = false;
  bool doVertical = false;
  bool doDiagonalXY = false;
  bool doDiagonalOpp = false;
  // NONE, HORIZONTAL, VERTICAL, DIAGONALXY, DIAGONALOPP
  Axis axis = NONE;
  
// Check if first move on the centre
  assert (moves.size() > 0);
  //int movesSize = moves.size();
  int startMove = 0;
  move = moves[0];
  if ((MID_BOARD == move.x) && (MID_BOARD == move.y)) {
    startMove = 1; // Start after the first move on the centre
  }
  
  bool flag;
  move = moves[startMove];
  bool doAxis = false;
  unsigned int i;
//   std::cout << "startMove = " << startMove << std::endl;
  // Do Horizontal check if on axis.
  // If it is not then check if we need to transform the orientation
  
  if (move.x < MID_BOARD) {
    doHorizontal = true;
//     qDebug("doHorizontal");
  }
  else if (MID_BOARD == move.x) {
//     qDebug("onHor Axis");
    axis = HORIZONTAL;
    i = startMove;
    flag = true;
    while ((i < moves.size()) && (flag == true)) {
      if (MID_BOARD == moves[i].x) {
        ++i;
      }
      else {
        flag = false;
      }
    }
    if (moves[i].x < MID_BOARD) {
      doAxis = true;
    }
  }


  // vertical
  
  if (move.y > MID_BOARD) {
    doVertical = true;
//     qDebug("doVertical");
  }
  else if (MID_BOARD == move.y) {
//     qDebug("onVert Axis");
    axis = VERTICAL;
    i = startMove;
    flag = true;
    while ((i < moves.size()) && (flag == true)) {
      if (MID_BOARD == moves[i].y) {
        ++i;
      }
      else {
        flag = false;
      }
    }
    if (moves[i].y > MID_BOARD) {
      doAxis = true;
    }
  }

  
  // Diagonal XY
  
  if (move.y > move.x) {
    doDiagonalXY = true;
//     qDebug("doDiagonalXY");
  }
  else if (move.x == move.y) {
//     qDebug("onDiagXY Axis");
    axis = DIAGONALXY;
    i = startMove;
    flag = true;
    while ((i < moves.size()) && (flag == true)) {
      if (moves[i].x == moves[i].y) {
        ++i;
      }
      else {
        flag = false;
      }
    }
    if (moves[i].y > moves[i].x) {
      doAxis = true;
    }
  }

  
  
  // do y = end - x diagonal opp
  
  if (move.y > END_BOARD - move.x) {
    doDiagonalOpp = true;
//     qDebug("doDiagonalOpp");
  }
  else if (move.y == END_BOARD - move.x) {
//     qDebug("onDiagOpp Axis");
    axis = DIAGONALOPP;
    i = startMove;
    flag = true;
    while ((i < moves.size()) && (flag == true)) {
      if (moves[i].y == END_BOARD - moves[i].x) {
        ++i;
      }
      else {
        flag = false;
      }
    }
    if (moves[i].y > END_BOARD - moves[i].x) {
      doAxis = true;
    }
  }

  //   ----------------------------
  //   !\        2  ! 1           !
  //   !  \         !             !
  //   !     \      !             !
  //   !       \    !             !
  //   ! 3        \ !           8 !
  //   !--------------------------!
  //   ! 4          !           7 !
  //   !            !             !
  //   !            !             !
  //   !            !             !
  //   !          5 ! 6           !
  //   ----------------------------
  
  vector<FullMove>::iterator j;
  
  if (true == doAxis) {
//     qDebug("doAxis == true");
    switch (axis) {
      case HORIZONTAL : {
//         qDebug("Horizontal");
        for (j = moves.begin(); j != moves.end(); j++) {
          j->x = END_BOARD - (j->x); 
        }
        break;
      }
      case VERTICAL : {
//         qDebug("Vertical");
        for (j = moves.begin(); j != moves.end(); j++) {
          j->y = END_BOARD - (j->y);
        }
        break;
      }
      case DIAGONALXY : {
//         qDebug("DiagonalXY");
        for (j = moves.begin(); j != moves.end(); j++) {
          copy.x = j->x;
          j->x = j->y;
          j->y = copy.x;
        }
        break;
      }
      case DIAGONALOPP : {
//         qDebug("DiagonalOpp");
        for (j = moves.begin(); j != moves.end(); j++) {
          copy.x = j->x;
          j->x = END_BOARD - j->y;
          j->y = END_BOARD - copy.x;
        }
        break;
      }
      case NONE : {}
      default : {}
    }
  }
  
  
  
  
  // Switch and do tranforms
  
  int count = 0;
  if (true == doHorizontal) {
    count += 1;
  }
  if (true == doVertical) {
    count += 2;
  }
  if (true == doDiagonalXY) {
    count += 4;
  }
  if (true == doDiagonalOpp) {
    count += 8;
  }
  
  
//   std::cout << "switch count = " << count << std::endl;
  switch (count) {
    case 1 : { // hor (2)
      for (j = moves.begin(); j != moves.end(); j++) {
        j->x = END_BOARD - (j->x); 
      }
      break; // hor
    }
    case 5 : { // Hor + diag xy (3)
      for (j = moves.begin(); j != moves.end(); j++) {
        // FIXME TODO not sure if right
        copy.y = j->y;
        j->y = j->x;
        j->x = END_BOARD - copy.y;
      }
      break; // rotate clockwise 90 deg
    }
    case 7 : { // diag xy + hor  + vert (4)
      for (j = moves.begin(); j != moves.end(); j++) {
        copy.x = j->x;
        j->x = j->y;
        j->y = copy.x;
      }
      break; // just diag xy
    }
    case 15 : { // diag xy + hor  + vert + diag opp (5)
      for (j = moves.begin(); j != moves.end(); j++) {
        j->x = END_BOARD - (j->x);
        j->y = END_BOARD - (j->y);
      }
      break; // hor + vert
    }
    case 14 : { // diag xy + vert + diag opp (6)
      for (j = moves.begin(); j != moves.end(); j++) {
        j->y = END_BOARD - (j->y);
      }
      break; // vert
    }
    case 10 : { // vert + diag opp (7)
      for (j = moves.begin(); j != moves.end(); j++) {
        // FIXME TODO
        copy.y = END_BOARD - j->y;
        j->y = END_BOARD - j->x;
        j->x = END_BOARD - copy.y;
      }
      break; // rotate 90 deg anit clockwise
    }
    case 8 : { // diag opp (8)
      for (j = moves.begin(); j != moves.end(); j++) {
        copy.x = j->x;
        j->x = END_BOARD - j->y;
        j->y = END_BOARD - copy.x;
      }
      break; // diag opp
    }
  } // switch


  /************************************************************************
  // Now we want to do transforms for moves 4 upwards, 
  // to take care of symmetrical positions.
  
  // Check if move 1-4 contain moves in an axis.
//   bool test = true;
  
  //Four move test
  // horizontal axis  symmetry
  **************************************************************************/

  if (moves.size() >= 4) {
    doSymmetries(4);
  }
  if (moves.size() >= 5) {
    doSymmetries(5);
  }
  if (moves.size() >= 6) {
    doSymmetries(6);
  }
  if (moves.size() >= 7) {
    doSymmetries(7);
  }
  if (moves.size() >= 8) {
    doSymmetries(8);
  }
  
  return true; // FIXME make void function
}




// Here symmetries with 4 or more moves are done.
void Sgf::doSymmetries(int iMove)
{
  vector<FullMove>::iterator j;
  int i;
  bool isAxis;
  FullMove copy;
  FullMove move;
  
  // If we get a false at anytime then skip the rest of the testing.
  
  i = 0;
  do {
    isAxis = false;
    move = moves[i];
    for (int j = 0; j < iMove; j++) {
      if ((move.y == moves[j].y) && (move.x == END_BOARD - moves[j].x) &&
            (move.colour == moves[j].colour)) {
        ++i;
        isAxis = true;
      }
    }
  }
  while ((true == isAxis) && (i < iMove));
//     qDebug("done hor");
  if ((true == isAxis) && (MID_BOARD > moves[iMove].x)) {
//         qDebug("4 move hor symmetry");
    for (j = moves.begin() + iMove; j != moves.end(); j++) {
      j->x = END_BOARD - (j->x);
    }
  }

  
  // Do for vertical axis symmetry - flip 
  i = 0;
  do {
    isAxis = false;
    move = moves[i];
    for (int j = 0; j < iMove; j++) {
      if ((move.x == moves[j].x) && (move.y == END_BOARD - moves[j].y) &&
            (move.colour == moves[j].colour)) {
        ++i;
        isAxis = true;
      }
    }
  }
  while ((true == isAxis) && (i < iMove));
//     qDebug("done vert");
  if ((true == isAxis) && (MID_BOARD < moves[iMove].y)) {
//        qDebug("4 move vert symmetry");
    for (j = moves.begin() + iMove; j != moves.end(); j++) {
      j->y = END_BOARD - (j->y);
    }
  }


  // DiagonalXY flip
  
  i = 0;
  do {
    isAxis = false;
    move = moves[i];
    for (int j = 0; j < iMove; j++) {
      if ((move.x == moves[j].y) && (move.y == moves[j].x) &&
            (move.colour == moves[j].colour)) {
        ++i;
        isAxis = true;
      }
    }
  }
  while ((true == isAxis) && (i < iMove));
//     qDebug("done diagxy");
  if ((true == isAxis) && (moves[iMove].y > moves[iMove].x)) {
//       qDebug("4 move hor symmetry");
    for (j = moves.begin() + iMove; j != moves.end(); j++) {
      copy.x = j->x;
      j->x = j->y;
      j->y = copy.x;
    }
  }

  // Do for diagonal Opp axis symmetry - flip 
  i = 0;
  do {
    isAxis = false;
    move = moves[i];
    for (int j = 0; j < iMove; j++) {
      if ((move.x == END_BOARD - moves[j].y) && (move.y == END_BOARD - moves[j].x) &&
            (move.colour == moves[j].colour)) {
        ++i;
        isAxis = true;
      }
    }
  }
  
  while ((true == isAxis) && (i < iMove));
//     qDebug("done diagopp");
  if ((true == isAxis) && (moves[iMove].y > END_BOARD - moves[iMove].x)) {
//       qDebug("4 move hor symmetry");
    for (j = moves.begin() + iMove; j != moves.end(); j++) {
      copy.x = j->x;
      j->x = END_BOARD - j->y;
      j->y = END_BOARD - copy.x;
    }
  }

  
  
  
  // Do for Rotation 180 degrees axis symmetry.
  i = 0;
  do {
    isAxis = false;
    move = moves[i];
    for (int j = 0; j < iMove; j++) {
      if ((move.x == END_BOARD - moves[j].x) && (move.y == END_BOARD - moves[j].y) &&
            (move.colour == moves[j].colour)) {
        ++i;
        isAxis = true;
      }
    }
  }
  while ((true == isAxis) && (i < iMove));
//     qDebug("done rotate");
  if ((true == isAxis) && (moves[iMove].y > MID_BOARD)) {
//     qDebug("4 move rotate");
    for (j = moves.begin() + iMove; j != moves.end(); j++) {
      j->x = END_BOARD - j->x;
      j->y = END_BOARD - j->y;
    }
  }
}




//--------------------------------------------------------
//Generate unique game signature based on all moves
//Not too much extra time needed to compute all moves 
//This means we dont need to double check for duplicates - simple ;)
//---------------------------------------------------------
u64 Sgf::fnvSignature() 
{
  string sig = "";
  for (u32 i = 0; i < moves.size(); i++) {
    sig += moves[i].x;
    sig += moves[i].y;
  }
  u64 hash = FNV1aHash(sig);
  return hash;
}

//-----------------------------------------------------------------
//use 64 bit hash as it gives zero collisions on roughly 100,000 games
//64 bit seems to works just fine - 32 bit hash did give collisions 
//-----------------------------------------------------------------
u64 Sgf::FNV1aHash(const string& sig)
{
  u64 hval = 0xcbf29ce484222325ULL; //initialise value
  for (string::size_type i = 0; i < sig.size(); i++) {
    hval ^= static_cast<u64> (sig[i]); // xor the bottom with the current octet
    //hval *= 0x100000001b3ULL  // multiply by the 64 bit FNV magic prime mod 2^64
    //GCC optimised version
    hval += (hval << 1) + (hval << 4) + (hval << 5) + (hval << 7) + 
            (hval << 8) + (hval << 40);
  }
  return hval;
}


//----------------------------------------
void Sgf::initTransArrays() 
{
  for (int x = 0; x < 19; x++) {
    transHorizontal_[x].x = (END_BOARD - x); 
    for (int y = 0; y < 19; y++) {
      transVertical_[y].y = (END_BOARD - y); 
      transMirror_[x][y].x = (END_BOARD - y);
      transMirror_[x][y].y = (END_BOARD - x);
      transRotate_[x][y].x = (MID_BOARD + (MID_BOARD - y));
      transRotate_[x][y].y = x;
    }
  }
}



//------------------------------------
//! Game moves transform functions
//--------------------------------------
void Sgf::xAxisMirror() 
{ 
  vector<FullMove>::iterator i;
  for (i = moves.begin(); i != moves.end(); ++i) {
    i->x = transHorizontal_[i->x].x;
  }
}



void Sgf::yAxisMirror() 
{
  vector<FullMove>::iterator i;
  for (i = moves.begin(); i != moves.end(); ++i) {
    i->y = transVertical_[i->y].y;
  }
}



void Sgf::diagonalMirror()  // top right - bottom left
{
  FullMove tmp;
  vector<FullMove>::iterator i;
  for (i = moves.begin(); i != moves.end(); ++i) {
    tmp.x = transMirror_[i->x][i->y].x;
    i->y = transMirror_[i->x][i->y].y;
    i->x = tmp.x;
  }
}



void Sgf::rotate()  // clockwise
{
  FullMove tmp;
  vector<FullMove>::iterator i = moves.begin();
  for (i = moves.begin(); i != moves.end(); ++i) {
    tmp.x = transRotate_[i->x][i->y].x;
    i->y = transRotate_[i->x][i->y].y;
    i->x = tmp.x;
  }
}




/////////////////////////////////////////////////////////////////////
//! DEBUG CODE
/////////////////////////////////////////////////////////////////////

void Sgf::printHead() { cout << sgfFile_ << endl; }

void Sgf::printMoves(){
  vector<FullMove>::const_iterator i=moves.begin();
  for (i = moves.begin(); i != moves.end(); i++) {
    cout << (char)((i->x) + 'a') << (char)((i->y) + 'a');
    cout << (char)((i->colour) + '0') << " ";
  }
  cout << endl;
}
