
#include <QPainter>
#include <QFont>
#include <QSettings>

#ifdef WIN32
#include <C:\Boost\include\boost-1_33_1\boost\lexical_cast.hpp>
#else
#include "boost/lexical_cast.hpp"
#endif





#include "StatisticsBlackTab.h"

using boost::lexical_cast;

StatisticsBlackTab::StatisticsBlackTab(MainWindow* mainWindow, QWidget *parent) : QWidget(parent),
        mainWindow_(mainWindow)
{
}



void StatisticsBlackTab::paintEvent(QPaintEvent *)
{
  if (true == mainWindow_->boardWindows_.empty()) {
    return;
  }
  QPainter painter(this);
  painter.setRenderHint(QPainter::Antialiasing, true);
  QPen pen(Qt::black, 1);
  painter.setPen(pen);
   //   QColor color( 150, 10, 10, 255 ); // r,g,b
  int widgetWidth = width() - 20;
//   QLinearGradient linearGrad(QPointF(0, 0), QPointF(widgetWidth, 0));
//   linearGrad.setColorAt(0, Qt::red);
//   linearGrad.setColorAt(1, Qt::white);
//   QBrush brush(linearGrad);
  int wins;
  double max = 0;
  
  double scale;
  int length;
  vector<boost::shared_ptr<Continuations> >::iterator i;
  // Find the nextmove with greatest number of games matched
  
  double percentage;
  double bwins;
  int percentageRounded;
  
  QSettings settings;
  int num = settings.value("Configuration/NextMoveCount", 20).toInt();
//   qDebug("hello1");
  int j = 0;
  
//   std::cout << "statsBlack size = " << mainWindow_->selectedBoardWindow_->mainBoard->statsBlack.size()
//       << std::endl;
  i = mainWindow_->selectedBoardWindow_->mainBoard->statsBlack.begin();
  while ((j < num) && (i != mainWindow_->selectedBoardWindow_->mainBoard->statsBlack.end())) {
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);
//     assert (wins > 0);
    if (wins > max) {
      max = wins;
    }
    ++i;
    ++j;
  }
  scale = max / widgetWidth;
  
//   qDebug("hello2");
  QString letters("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
  QString text;
  QString stats;
  QFont sansFont("Courier", 12);
  sansFont.setWeight(QFont::Normal);
  painter.setFont(sansFont);
  
  int ypos = 5;
  int count = 0;
  
  std::string percent;
  std::string total;
  std::string statext;
  
  // Display % of black wins and total games found
  j = 0;
  i = mainWindow_->selectedBoardWindow_->mainBoard->statsBlack.begin();
  while ((j < num) && (i != mainWindow_->selectedBoardWindow_->mainBoard->statsBlack.end())) {
//     std::cout << "statsBlack = " << j << std::endl;
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);

    //! NOTE what we do if if a jigo we count it as two games and add a win for black
    //! and a win for white, so to cancel each other out.
    // This lets us with 1 jigo game have a 50% of a win.
    
    
    length = static_cast<int>((wins / scale));
    QLinearGradient linearGrad(QPointF(0, 0), QPointF(length, 0));
    linearGrad.setColorAt(0, Qt::red);
    linearGrad.setColorAt(1, Qt::white);
    QBrush brush(linearGrad);
    painter.drawRect ( 15, ypos, length, 18);
    painter.fillRect ( 15, ypos + 1, length, 16, brush);
    
    text.clear();
    text.append(letters[count]);
    count++;
    painter.drawText ( 0, ypos + 2, 15, 20, Qt::AlignCenter, text, 0 );
//     qDebug("calculating percentages for statsBlackTab");
    
    //! NOTE see above for note about Jigo stats
//     wins = ((*i)->blackWins);
//     wins += ((*i)->whiteWins);
//     wins += ((*i)->jigo) * 2;

//     bwins = ((*i)->blackWins) + ((*i)->jigo);
     bwins = ((*i)->blackWins);
    
    if (wins != 0) {
      percentage = bwins / wins;
    }
    else {
      percentage = 0;
    }
    percentage = percentage * 100;
    percentageRounded = static_cast<int>(percentage);
    percent = lexical_cast<std::string>(percentageRounded);
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);
    total = lexical_cast<std::string>(wins);
    statext = percent + "% Win : " + total + " Games";
    stats = statext.c_str();
    painter.drawText ( 25, ypos + 1, 200, 20, Qt::AlignLeft, stats, 0 );
    ypos += 22;
    ++i;
    ++j;
  }
}



// Stats already sorted at this stage
// Find the biggest entry, so we know how to scale the bar graph
void StatisticsBlackTab::showStatisticsBlack()
{
  update();
}


