
#include <QPainter>
#include <QSettings>

#ifdef WIN32
#include <C:\Boost\include\boost-1_33_1\boost\lexical_cast.hpp>
#else
#include "boost/lexical_cast.hpp"
#endif



#include "StatisticsWhiteTab.h"

using boost::lexical_cast;

StatisticsWhiteTab::StatisticsWhiteTab(MainWindow* mainWindow, QWidget *parent) : 
    QWidget(parent), mainWindow_(mainWindow)
{
}


void StatisticsWhiteTab::paintEvent(QPaintEvent *)
{
  if (true == mainWindow_->boardWindows_.empty()) {
    return;
  }
    
  QPainter painter(this);
  painter.setRenderHint(QPainter::Antialiasing, true);
  QPen pen(Qt::black, 1);
  painter.setPen(pen);
   //   QColor color( 150, 10, 10, 255 ); // r,g,b
  int widgetWidth = width() - 20;
//   QLinearGradient linearGrad(QPointF(0, 0), QPointF(widgetWidth, 0));
//   linearGrad.setColorAt(0, Qt::red);
//   linearGrad.setColorAt(1, Qt::white);
//   QBrush brush(linearGrad);
  int wins;
  double max = 0;
  
  double scale;
  int length;
  vector<boost::shared_ptr<Continuations> >::iterator i;
  // Find the nextmove with greatest number of games matched
  
  double percentage;
  double wwins;
  int percentageRounded;
  
  QSettings settings;
  int num = settings.value("Configuration/NextMoveCount", 20).toInt();
  
  int j = 0;
  i = mainWindow_->selectedBoardWindow_->mainBoard->statsWhite.begin();
  while ((j < num) && (i != mainWindow_->selectedBoardWindow_->mainBoard->statsWhite.end())) {
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);
    if (wins > max) { 
      max = wins;
    }
    ++i;
    ++j;
  }
  scale = max / widgetWidth;
  
  QString letters("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
  QString text;
  QString stats;
  
  std::string percent;
  std::string total;
  std::string statext;
  
  QFont sansFont("Courier", 12);
  sansFont.setWeight(QFont::Normal);
  painter.setFont(sansFont);
  
  int ypos = 5;
  int count = 0;
  
  
  // Display % of black wins and total games found
  j = 0;
  
  i = mainWindow_->selectedBoardWindow_->mainBoard->statsWhite.begin();
  while ((j < num) && (i != mainWindow_->selectedBoardWindow_->mainBoard->statsWhite.end())) {
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);
    length = static_cast<int>((wins / scale));
    QLinearGradient linearGrad(QPointF(0, 0), QPointF(length, 0));
    linearGrad.setColorAt(0, Qt::red);
    linearGrad.setColorAt(1, Qt::white);
    QBrush brush(linearGrad);
    painter.drawRect ( 15, ypos, length, 18);
    painter.fillRect ( 15, ypos + 1, length, 16, brush);
    
    text.clear();
    text.append(letters[count]);
    count++;
    painter.drawText ( 0, ypos + 2, 15, 20, Qt::AlignCenter, text, 0 );
    
//     qDebug("calculating percentages for statsWhiteTab");
//     wins = ((*i)->blackWins);
//     wins += ((*i)->whiteWins);
//     wins += ((*i)->jigo) * 2;
//     wwins = ((*i)->whiteWins) + ((*i)->jigo);
    wwins = ((*i)->whiteWins);
    if (wins != 0) {
      percentage = wwins / wins;
    }
    else {
      percentage = 0;
    }
    percentage = percentage * 100;
    percentageRounded = static_cast<int>(percentage);
    percent = lexical_cast<std::string>(percentageRounded);
    wins = ((*i)->blackWins);
    wins += ((*i)->whiteWins);
    wins += ((*i)->jigo);
    total = lexical_cast<std::string>(wins);
    statext = percent + "% Win : " + total + " Games";
    stats = statext.c_str();
    painter.drawText ( 25, ypos + 1, 200, 20, Qt::AlignLeft, stats, 0 );
    ypos += 22;
    ++i;
    ++j;
  }
}



void StatisticsWhiteTab::showStatisticsWhite()
{
    update();
}
