// ToolBarBoard.cpp 
// baduk 0.1 - Neil Mclean
// started 12/7/2006

#include <QMainWindow>
#include <QPainter>
#include <stdlib.h>
#include <QtGui>

#include "ToolBarBoard.h"

ToolBarBoard::ToolBarBoard(MainWindow* mainWindow, QWidget *parent)
  : QToolBar(parent), mainWindow_(mainWindow)
{
    setWindowTitle(tr("Board orientation toolbar"));
    setObjectName("ToolBarBoard");
    setIconSize(QSize(20, 20));

    rotateAct = new QAction( QIcon(":/resources/icons/rotate.png"), "Rotate board 90 degrees clockwise", this);
    horizontalMirrorAct = new QAction( QIcon(":/resources/icons/horizontalflip.png"), "Mirror board horizontally", this);
    verticalMirrorAct = new QAction( QIcon(":/resources/icons/verticalflip.png"), "Mirror board vertically", this);
    addAction(rotateAct);
    addAction(horizontalMirrorAct);
    addAction(verticalMirrorAct);
}



void ToolBarBoard::closeEvent(QCloseEvent *event)
{
//   mainWindow_->checkToolbarBoard();
  event->accept();
}



void ToolBarBoard::setToolBarState(bool on)
{
  rotateAct->setEnabled(on);
  horizontalMirrorAct->setEnabled(on);
  verticalMirrorAct->setEnabled(on);
}
