

#include <QMainWindow>
#include <QPainter>
#include <stdlib.h>
#include <QtGui>
#include <iostream>

#include "ToolBarEdit.h"

ToolBarEdit::ToolBarEdit(MainWindow* mainWindow, QWidget *parent)
  : QToolBar(parent), mainWindow_(mainWindow)
{
    setWindowTitle(tr("Board edit toolbar"));
    setObjectName("ToolBarEdit");
    setIconSize(QSize(20, 20));
    
    eraseAct = new QAction( QIcon(":/resources/icons/rubber.png"), tr("&Erase"), this);
    alternateAct = new QAction( QIcon(":/resources/icons/alternatestoneicon.png"), tr("&Alternate / Toggle colour"), this);
    addBlackAct = new QAction( QIcon(":/resources/icons/blackstoneicon.png"), tr("&Add black"), this);
    addWhiteAct = new QAction( QIcon(":/resources/icons/whitestoneicon.png"), tr("&Add white"), this);
    addAction(eraseAct);
    addAction(alternateAct);
    addAction(addBlackAct);
    addAction(addWhiteAct);
}


void ToolBarEdit::closeEvent(QCloseEvent *event)
{
//   mainWindow_->checkToolbarEdit();
  event->accept();
}



void ToolBarEdit::setToolBarState(bool on)
{
  eraseAct->setEnabled(on);
  alternateAct->setEnabled(on);
  addBlackAct->setEnabled(on);
  addWhiteAct->setEnabled(on);
}


