

#include <QMainWindow>
#include <QPainter>
#include <stdlib.h>
#include <QtGui>

#include "ToolBarMoves.h"

ToolBarMoves::ToolBarMoves(MainWindow* mainWindow, QWidget *parent)
  : QToolBar(parent), mainWindow_(mainWindow)
{
    setWindowTitle(tr("Preview board navigation toolbar"));
    setObjectName("ToolBarMoves");
    setIconSize(QSize(16, 16));
    
    firstAct = new QAction( QIcon(":/resources/icons/3back.png"), tr("To Start"), this);
    addAction(firstAct);
    backTenAct = new QAction( QIcon(":/resources/icons/2back.png"), tr("Back ten moves"), this);
    addAction(backTenAct);
    backAct = new QAction( QIcon(":/resources/icons/1back.png"), tr("Back one move"), this);
    addAction(backAct);
    addSeparator();
    forwardAct = new QAction( QIcon(":/resources/icons/1forward.png"), tr("Forward one move"), this);
    addAction(forwardAct);
    forwardTenAct = new QAction( QIcon(":/resources/icons/2forward.png"), tr("Forward ten moves"), this);
    addAction(forwardTenAct);
    lastAct = new QAction( QIcon(":/resources/icons/3forward.png"), tr("To End"), this);
    addAction(lastAct);
  
}



void ToolBarMoves::closeEvent(QCloseEvent *event)
{
//   mainWindow_->checkToolbarMoves();
  event->accept();
}



void ToolBarMoves::setToolBarState(bool on)
{
  firstAct->setEnabled(on);
  backTenAct->setEnabled(on);
  backAct->setEnabled(on);
  forwardAct->setEnabled(on);
  forwardTenAct->setEnabled(on);
  lastAct->setEnabled(on);
}

