//WholeBoard.cpp
//baduK++ 0.1 - Neil Mclean 5/4/2006

#include <iostream>
#include <fstream>
#include <cassert>
#include <QApplication>

#include "WholeBoard.h"
#include "Pattern.h"
#include "Game.h"
#include "Const.h"
#include "Resources.h"

#ifdef WIN32
#include <C:\Boost\include\boost-1_33_1\boost\shared_ptr.hpp>
#else
#include "boost/shared_ptr.hpp"
#endif


using namespace std;
    
//setup static mersenne twisters for zobrist hash
//If first time Board class is constructed then load random numbers
//from file into 2d array.


WholeBoard::WholeBoard() : wbPatternSelected_(0)
{
  if (isMtrand64FirstInstance_ = true) { //static bool flag
    initializeMtrand64();
    initializeMtrandVariations();
    isMtrand64FirstInstance_ = false;
  }
  for (size_t i = 0; i < WB_INVARIANTS; i++) {
    wbPatterns_[i] = 0;
  }
}



WholeBoard::~WholeBoard() {}



/*

FullMove WholeBoard::invariantMove(FullMove move) 
{
  cout << "wbPatternSelected_ = " << (int)wbPatternSelected_ << endl;
  FullMove tmp;
//   u8 count = 0;
  if (1 == wbPatternSelected_) { // 1 Horizontal
    move.x = END_BOARD - move.x;
    cout << "1 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (2 == wbPatternSelected_) { // 2  Diagonal opposite + Hor
    tmp.x = move.y;
    move.y = move.x;
    move.x = tmp.x;
    move.x = END_BOARD - move.x;
    cout << "2 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (3 == wbPatternSelected_) { // 3 Diag opposite
    tmp.x = move.y;
    move.y = move.x;
    move.x = tmp.x;
    cout << "3 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (4 == wbPatternSelected_) { // 4 Hor + Vert
    move.x = END_BOARD - move.x;
    move.y = END_BOARD - move.y;
//     ++count;
    cout << "4 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (5 == wbPatternSelected_) { // 5 Vertical
    move.y = END_BOARD - move.y;
    cout << "5 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (6 == wbPatternSelected_) { // 6 Diag + Vert
    tmp.x = END_BOARD - move.y;
    move.y = END_BOARD - move.x;
    move.x = tmp.x;
    move.y = END_BOARD - move.y;
        cout << "6 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (7 == wbPatternSelected_) { // 7 Diagonal
    tmp.x = END_BOARD - move.y;
    move.y = END_BOARD - move.x;
    move.x = tmp.x;
    cout << "7 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  return move;
}

*/






FullMove WholeBoard::invariantMove(FullMove move) 
{
//   cout << "wbPatternSelected_ = " << (int)wbPatternSelected_ << endl;
  FullMove tmp;
//   u8 count = 0;
  if (1 == wbPatternSelected_) { // 1 Horizontal
    move.x = END_BOARD - move.x;
//     cout << "1 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (2 == wbPatternSelected_) { // 2  vert
    move.y = END_BOARD - move.y;
//     cout << "2 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (3 == wbPatternSelected_) { // 3 hor vert
    move.y = END_BOARD - move.y;
    move.x = END_BOARD - move.x;
//     cout << "3 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (4 == wbPatternSelected_) { // 4 diag
    tmp.x = END_BOARD - move.y;
    move.y = END_BOARD - move.x;
    move.x = tmp.x;
//     ++count;
//     cout << "4 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (5 == wbPatternSelected_) { // 5 hor + diag opp
    move.y = END_BOARD - move.y;
    tmp.x = move.y;
    move.y = move.x;
    move.x = tmp.x;
//     cout << "5 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (6 == wbPatternSelected_) { // 6 vert + diag opp
    move.x = END_BOARD - move.x;
    tmp.x = move.y;
    move.y = move.x;
    move.x = tmp.x;
//     cout << "6 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  if (7 == wbPatternSelected_) { // 7 hor + vert + diag
    move.x = END_BOARD - move.x;
    move.y = END_BOARD - move.y;
    tmp.x = END_BOARD - move.y;
    move.y = END_BOARD - move.x;
    move.x = tmp.x;
//     cout << "7 unIvnvariant selected : x&y=" << (int)move.x << " " << (int)move.y << endl;
  }
  return move;
}




//-----------------------------------------------------------------
// change next move to reflect pattern value invariant
// when search occurs the relevant next move 
// can be changed back to suit
// the search position. 
// relative to this invariant pattern selected.
// sounds complicated , but isnt.
// since taking least value of 8 invariants. 
// we have to change the next 
// move to suit the invariant taken.
void WholeBoard::generatePattern(boost::shared_ptr<Game> game) 
{
  u64 value = 0;
  string dud;
  FullMove move;
  
  u16 depth; //Use WholeBoard depth unless Game has less moves
  if (game->getMoveCount() < WHOLEBOARD_DEPTH) {
    depth = game->getMoveCount();
  }
  else {
    depth = WHOLEBOARD_DEPTH;
  }
//   cout << "WB patterns game=" << game->getIndex() << " " << 
//       game->getFilename() << endl;
  
  try {
    wbPatternSelected_ = 0;
    map<u64, boost::shared_ptr<Patterns> >::iterator iterPatterns;
    for (int j = 0; j < 8; j++) { //clear patterns
      wbPatterns_[j] = 0; 
    }
    
    
    u16 captureCount = 0;
    for (u16 iMove = 0; iMove < depth; iMove++) { // for each moveNumber
      boost::shared_ptr<GamesList> gameslist (new GamesList);
      gameslist->gameIndex = game->getIndex();
      if (iMove < game->getMoveCount()) {
        move = game->getGameMove(iMove);
//         cout << " xy="<< (int)move.x << " " << (int)move.y << " " << (int)move.colour;
        move = invariantMove(move); // move& changed
//      cout << " xy="<< (int)move.x << " " << (int)move.y << " " << (int)move.colour;
        
//         cout << "move no =" << (int)iMove;
//         cout << " xy="<< (int)move.x << " " << (int)move.y << " " << (int)move.colour;
//         cout << " wbPatternSelected=" << (int)wbPatternSelected_ << endl;
        
        gameslist->nextMoveX = move.x; //!Do
        gameslist->nextMoveY = move.y; //!Do xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        gameslist->nextMoveColour = move.colour; //!Do
      }
      else {
        gameslist->nextMoveX = 20; // pass move
        gameslist->nextMoveY = 20; // pass move
        gameslist->nextMoveColour = 0; // 
      }

      //! Keep a count of the number of captures made in the game so far.
      
      //! We need to take into account that captures will mean less stones on the board
      //! When we search for a pattern - we count how many stones there are on the board to
      //! determine the move number. Therefore we need to deduct the number of captures
      //! from move number to store the pattern correctly and retrieve correctly.
      
      gameslist->result = game->getResult();
      gameslist->moveNumber = iMove - captureCount;
      iterPatterns = patternMoveNumber[iMove - captureCount].find(value); 
      //if pattern exists already
      
      if (iterPatterns == patternMoveNumber[iMove - captureCount].end()) { //new pattern
        boost::shared_ptr<Patterns> patterns (new Patterns);
        patterns->zobHash = value;
        patterns->matches = 1; //increase no of games found with this pattern
        patternMoveNumber[iMove - captureCount].insert(make_pair (value, patterns));
        patterns->patternList.push_back(gameslist); //add game to Pattern List
      }
      else { //pattern matched with previous
        iterPatterns->second->patternList.push_back(gameslist); 
        iterPatterns->second->matches++;
      }
      
      //! This does the work - of finding zobrist pattern value
      value = patternValue(game, iMove); //do the next move to get WB pattern
      captureCount += game->iCaptures(iMove); // Keep count of captures - needed to
      // Allocate pattern value according to number of stones on the board.
      
//       cout << "gen WB value=" << value << endl;
      //string dud; cin >> dud;
    }
  }
  catch (bad_alloc& e) { 
    cout << "Error allocating memory" << e.what() << endl; 
  }
}




//---------------------------------------------------------------------
//get one pattern representing 8 invariants and its zobrist hash
//---------------------------------------------------------------------
u64 WholeBoard::patternValue(const boost::shared_ptr<Game>& game, u16 iMove)
{
  FullMove move = game->getGameMove(iMove);
  //cout << "patternvalue xy="<< (int)move.x << " " << (int)move.y << " " << (int)move.colour << endl;
  if (BLACK == move.colour) {
    for (u16 i = 0; i < 8; i++) {
      wbPatterns_[i] ^= mtrand64Black_[i][move.x][move.y]; 
    }
  }
  else if (WHITE == move.colour) {
    for (u16 i = 0; i < 8; i++) {
      wbPatterns_[i] ^= mtrand64White_[i][move.x][move.y]; 
    }
  }
  
  //If there are captures do them too
  u16 iCaptures = game->iCaptures(iMove);
  
  if (iCaptures > 0) {
//     cout << "captures here! num captures=" << int(iCaptures) << endl;
//     string dud; cin >> dud;
    for (u16 i = 0; i < iCaptures; i++) { //for each capture
      FullMove capture = game->getGameCapture ( iMove , i );
//       cout << "captures num=" << (int)(i) << " x&y = " << (int)(capture.x) << 
//           " " << (int)(capture.y) << endl;
      //Xor opposite colour of move since captures
      if (BLACK == move.colour) {
        for (u16 j = 0; j < 8; j++) {
          wbPatterns_[j] ^= mtrand64White_[j][capture.x][capture.y]; 
        }
      }
      else if (WHITE == move.colour) { 
        for (u16 j = 0; j < 8; j++) {
          wbPatterns_[j] ^= mtrand64Black_[j][capture.x][capture.y]; 
        }
      }
    }
  }
  u64 value = wbPatterns_[0];
  wbPatternSelected_ = 0;
  for (int i = 1; i < 8; i++) { //take least value pattern of 8 invariants
    if (wbPatterns_[i] < value) {
      value = wbPatterns_[i];
       // used to change next move to reflect invariant chosen
      wbPatternSelected_ = i;
    }
  }
  return value;
}



u64 WholeBoard::getMainBoardPattern(unsigned char board[19][19], u8& wbPatternSelected)
{
  u64 pattern[8];
  for (int i = 0; i <= 7; i++) { 
    pattern[i] = 0;
  }
  
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      for (int i = 0; i <= 7; i++) { 
    //       assert((board[x][y] <= 2) && (board[x][y] >= 0));
        if (BLACK == board[x][y]) {
          pattern[i] ^= mtrand64Black_[i][x][y];
        }
        else if (WHITE == board[x][y]) {
          pattern[i] ^= mtrand64White_[i][x][y];
        }
      }
    }
  }
  
  //take least value pattern of 8 invariants
  u64 value = pattern[0];
  wbPatternSelected = 0;
  for (int i = 1; i < 8; i++) {
    if (pattern[i] < value) {
      value = pattern[i];
      wbPatternSelected = i; // return value in parameter pass by reference
    }
  }
  return pattern[wbPatternSelected];
}





//-----------------------------------------------------------
//load mersenne twister arrays
//do only once since a static 2d array is loaded.
//-----------------------------------------------------------
void WholeBoard::initializeMtrand64() {
  try {
    string fileName = Resources::path("mt64.dat").toStdString();
    ifstream ifs;
    ifs.clear();
    ifs.open(fileName.c_str(), ios::in | ios::binary);
    if (ifs.is_open() == false) {
      throw ios_base::failure(fileName);
    }
    for (int i = 0; i <= 18; i++) {
      for (int j = 0; j <= 18; j++) {
        ifs.read((char*) &mtrand64Black_[0][i][j], sizeof  
            (mtrand64Black_[0][i][j]));
        ifs.read((char*) &mtrand64White_[0][i][j], sizeof 
            mtrand64White_[0][i][j]);
        //cout << " " << mtrand64Black[0][i][j] << " " << mtrand64White[0][i][j] << endl;
      }
    }
    ifs.close();
  }
  catch (ios_base::failure& e) { 
    cout << "Error I/O failure " << e.what() << endl; 
    abort();
  }
  //string dud; cin >> dud;
}



//----------------------------------------------------------------
// Apply xAxisMirrors and DiagonalMirrors to the Mtrand64 so to create
// 8 variations. Instead of changing the actual Game Board position by
// flipping and mirroring, we use the 8 Mtrand variations to do the work.
// This should be a HUGE speed up - eg. do all WholeBoard pattern generation
// In seconds not minutes.
//----------------------------------------------------------------
void WholeBoard::initializeMtrandVariations() 
{
  //do black mtrand variations
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      mtrand64Black_[1][x][y] = mtrand64Black_[0][END_BOARD - x][y];
      mtrand64Black_[2][x][y] = mtrand64Black_[0][x][END_BOARD - y];
      mtrand64Black_[3][x][y] = mtrand64Black_[0][END_BOARD - x][END_BOARD - y];
      mtrand64Black_[4][x][y] = mtrand64Black_[0][END_BOARD-y][END_BOARD-x];
      mtrand64Black_[5][x][y] = mtrand64Black_[1][y][x];
      mtrand64Black_[6][x][y] = mtrand64Black_[2][y][x];
      mtrand64Black_[7][x][y] = mtrand64Black_[3][END_BOARD-y][END_BOARD-x];
      
      mtrand64White_[1][x][y] = mtrand64White_[0][END_BOARD-x][y];
      mtrand64White_[2][x][y] = mtrand64White_[0][x][END_BOARD - y];
      mtrand64White_[3][x][y] = mtrand64White_[0][END_BOARD - x][END_BOARD - y];
      mtrand64White_[4][x][y] = mtrand64White_[0][END_BOARD-y][END_BOARD-x];
      mtrand64White_[5][x][y] = mtrand64White_[1][y][x];
      mtrand64White_[6][x][y] = mtrand64White_[2][y][x];
      mtrand64White_[7][x][y] = mtrand64White_[3][END_BOARD-y][END_BOARD-x];
    }
  }
  /*
  xAxisMirrorBlackMtrand(0, 1);
  diagonalMirrorBlackMtrand(1, 2);
  xAxisMirrorBlackMtrand(2, 3);
  diagonalMirrorBlackMtrand(3, 4);
  xAxisMirrorBlackMtrand(4, 5);
  diagonalMirrorBlackMtrand(5, 6);
  xAxisMirrorBlackMtrand(6, 7);
  
  //Now do white 
  xAxisMirrorWhiteMtrand(0, 1);
  diagonalMirrorWhiteMtrand(1, 2);
  xAxisMirrorWhiteMtrand(2, 3);
  diagonalMirrorWhiteMtrand(3, 4);
  xAxisMirrorWhiteMtrand(4, 5);
  diagonalMirrorWhiteMtrand(5, 6);
  xAxisMirrorWhiteMtrand(6, 7);
  */
}



void WholeBoard::xAxisMirrorBlackMtrand(const u8 in, const u8 out) 
{
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      mtrand64Black_[out][x][y] = mtrand64Black_[in][END_BOARD-x][y];
    }
  }
}

void WholeBoard::diagonalMirrorBlackMtrand(const u8 in, const u8 out) 
{
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      mtrand64Black_[out][x][y] = mtrand64Black_[in][END_BOARD-y][END_BOARD-x];
    }
  }
}

void WholeBoard::xAxisMirrorWhiteMtrand(const u8 in, const u8 out) 
{
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      mtrand64White_[out][x][y] = mtrand64White_[in][END_BOARD-x][y];
    }
  }
}

void WholeBoard::diagonalMirrorWhiteMtrand(const u8 in, const u8 out) 
{
  for (int x = 0; x < 19; x++) {
    for (int y = 0; y < 19; y++) {
      mtrand64White_[out][x][y] = mtrand64White_[in][END_BOARD-y][END_BOARD-x];
    }
  }
}
