;NSIS Modern User Interface
;Start Menu Folder Selection Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "baduK"
  OutFile "baduK.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\baduK"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\baduK" ""

;--------------------------------
;Variables

  Var MUI_TEMP
  Var STARTMENU_FOLDER



;--------------------------------
;Interface Configuration

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "C:\programming\baduk\release\resources\logo_header.bmp" ; optional
  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Docs\Modern UI\QLicence.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  
  ;Start Menu Folder Page Configuration
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU" 
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\baduK" 
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "baduK"
  
  !insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER
  
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "baduK" SecBaduk

  SetOutPath "$INSTDIR"
  
  ;ADD YOUR OWN FILES HERE...
  File "c:\programming\baduk\release\baduK.exe"
  File "c:\programming\baduk\mingwm10.dll"
  File "c:\programming\baduk\ReadMe.txt"
  
  CreateDirectory "$INSTDIR\Databases"

  CreateDirectory "$INSTDIR\resources"
  SetOutPath "$INSTDIR\resources"
  File "c:\programming\baduk\release\resources\Beige1.png"
  File "c:\programming\baduk\release\resources\Beige2.png"
  File "c:\programming\baduk\release\resources\Beige3.png"
  File "c:\programming\baduk\release\resources\logo_header.gif"
  File "c:\programming\baduk\release\resources\mt64.dat"
 
  CreateDirectory "$INSTDIR\resources\BlackStones"
  SetOutPath "$INSTDIR\resources\BlackStones"
  File "c:\programming\baduk\release\resources\BlackStones\*.*"

  CreateDirectory "$INSTDIR\resources\Tsuke.stones"
  SetOutPath "$INSTDIR\resources\Tsuke.stones"
  File "c:\programming\baduk\release\resources\Tsuke.stones\*.*"

  ;Store installation folder
  WriteRegStr HKCU "Software\baduK" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"
  
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    
    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\baduK.lnk" "$INSTDIR\baduK.exe"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\baduK ReadMe.lnk" "$INSTDIR\ReadMe.txt"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall baduK.lnk" "$INSTDIR\Uninstall.exe"
  
  !insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecBaduK ${LANG_ENGLISH} "Install baduK."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecBaduk} $(DESC_SecBaduk)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...
  Delete "$INSTDIR\baduK.exe"
  Delete "$INSTDIR\mingwm10.dll"
  Delete "$INSTDIR\GeneralSettings.ini"
  Delete "$INSTDIR\ReadMe.txt"
  Delete "$INSTDIR\Uninstall.exe"
  RMDir "$INSTDIR\Databases"
  RMDir "$INSTDIR\Resources"
  RMDir "$INSTDIR"

  
  !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP
    
  Delete "$SMPROGRAMS\$MUI_TEMP\Uninstall baduK.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\baduK.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\baduK ReadMe.lnk"

  
  ;Delete empty start menu parent diretories
  StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"
 
  startMenuDeleteLoop:
	ClearErrors
    RMDir $MUI_TEMP
    GetFullPathName $MUI_TEMP "$MUI_TEMP\.."
    
    IfErrors startMenuDeleteLoopDone
  
    StrCmp $MUI_TEMP $SMPROGRAMS startMenuDeleteLoopDone startMenuDeleteLoop
  startMenuDeleteLoopDone:

  DeleteRegKey /ifempty HKCU "Software\baduK"

SectionEnd