TEMPLATE = app
CONFIG += static
RESOURCES = application.qrc

win32 {
DEFINE += WIN32
RC_FILE = baduk.rc
BOOSTPATH = C:\Boost\include\boost-1_33_1
LIBS += C:\Boost\lib\libboost_filesystem-gcc.lib
}

macx {
BOOSTPATH = /usr/local/boost-1.33.1/include/boost-1_33_1
LIBS += /usr/local/boost-1.33.1/lib/libboost_filesystem-1_33_1.a
QMAKE_POST_LINK += mkdir -p baduk.app/Contents/Resources;
QMAKE_POST_LINK += rsync -r --exclude=\*.svn resources/* baduk.app/Contents/Resources;
}

linux {
BOOSTPATH = /usr/include
LIBS += /usr/lib/libboost_filesystem-1_33_1.a
}

INCLUDEPATH += $$BOOSTPATH

HEADERS += AddDatabase.h \
           Board.h \
           Configuration.h \
           Const.h \
           Database.h \
           DatabaseTab.h \
           DatabaseViewer.h \
           DbManager.h \
           Directory.h \
           Filters.h \
           FreeSearch.h \
           Game.h \
           GameInfo.h \
           GamesTab.h \
           LogFile.h \
           MainBoard.h \
           MainWindow.h \
           Pattern.h \
           PreviewBoard.h \
           Resources.h \
           Sgf.h \
           StatisticsBlackTab.h \
           StatisticsWhiteTab.h \
           Timer.h \
           ToolBarBoard.h \
           ToolBarEdit.h \
           ToolBarMainMoves.h \
           ToolBarMoves.h \
           WholeBoard.h \
           $$BOOSTPATH/boost/lexical_cast.hpp \
           $$BOOSTPATH/boost/shared_ptr.hpp \
           $$BOOSTPATH/boost/scoped_ptr.hpp \
           $$BOOSTPATH/boost/filesystem/operations.hpp \
           $$BOOSTPATH/boost/filesystem/fstream.hpp \
           $$BOOSTPATH/boost/timer.hpp \
           $$BOOSTPATH/boost/filesystem/path.hpp \
           $$BOOSTPATH/boost/date_time/gregorian/gregorian.hpp \
           $$BOOSTPATH/boost/format.hpp \
           $$BOOSTPATH/boost/cast.hpp
SOURCES += AddDatabase.cpp \
           Board.cpp \
           Configuration.cpp \
           Database.cpp \
           DatabaseTab.cpp \
           DatabaseViewer.cpp \
           DbManager.cpp \
           Directory.cpp \
           Filters.cpp \
           FreeSearch.cpp \
           Game.cpp \
           GameInfo.cpp \
           GamesTab.cpp \
           LogFile.cpp \
           main.cpp \
           MainBoard.cpp \
           MainWindow.cpp \
           Pattern.cpp \
           PreviewBoard.cpp \
           Resources.cpp \
           Sgf.cpp \
           StatisticsBlackTab.cpp \
           StatisticsWhiteTab.cpp \
           Timer.cpp \
           ToolBarBoard.cpp \
           ToolBarEdit.cpp \
           ToolBarMainMoves.cpp \
           ToolBarMoves.cpp \
           WholeBoard.cpp
