
// Main.cpp 
// baduK 0.1 - Neil Mclean 
// started project 4/3/06

#include <QMessageBox>
#include <QApplication>
#include <vector>
#include <QStandardItemModel>
#include <QTableView>
#include <QTreeView>
#include <QAbstractItemModel>
#include <QSortFilterProxyModel>
#include <QHeaderView>
#include <QtGui>
#include <QTimer>
#include <QString>

#include "MainWindow.h"

#include <iostream>
#include <string>
#include <fstream>
#include <ctime>

#include "DbManager.h"
#include "Const.h"
#include "Resources.h"

//For initMtrand setup initially
bool WholeBoard::isMtrand64FirstInstance_ = true;
u64 WholeBoard::mtrand64Black_[WB_INVARIANTS][BOARD_SIZE][BOARD_SIZE];
u64 WholeBoard::mtrand64White_[WB_INVARIANTS][BOARD_SIZE][BOARD_SIZE];


int main( int argc, char **argv )
{  
  QApplication app(argc, argv);
  app.setApplicationName("baduk");
  app.setOrganizationDomain("sourceforge.net");
  app.setOrganizationName("baduk.sourceforge.net");
  
  //#ifdef WIN32
    Q_INIT_RESOURCE(application);
  //#endif
  QSplashScreen *splash = new QSplashScreen(QPixmap(":/resources/logo_header.gif"));
  splash->show();
  qApp->processEvents();
  // Pass the application dir
  DbManager dbManager(Resources::userPath().toStdString()); // instance of the Backend system
  dbManager.initializeDatabases();
  MainWindow mainWin(&dbManager); //give dbManager backend pointer to GUI
  
  mainWin.show();
  splash->finish(&mainWin);
  delete splash;
  
  return app.exec();
//   exit(EXIT_SUCCESS);
}

